<?php
/**
 * Plugin Name:  افزونه درگاه آقای پرداخت برای LifterLMS
 * Plugin URI: https://aqayepardakht.ir
 * Description: توسط این افزونه میتوانید از درگاه آقای پرداخت در افزونه LifterLMS استفاده نمایید.
 * Version: 1.1.0
 * Author: آقای پرداخت
 * Author URI: https://aqayepardakht.ir
 *
 * @package 		LifterLMS Aqayepardakht
 * @category 	Core
 * @author 		LifterLMS
 */

if ( ! defined( 'ABSPATH' ) ) exit;

if ( ! class_exists( 'LifterLMS_Aqayepardakht') ) :

    final class LifterLMS_Aqayepardakht {
        public $version = '1.1.0';
        protected static $_instance = null;
        public static function instance() {
            if ( is_null( self::$_instance ) ) {
                self::$_instance = new self();
            }
            return self::$_instance;
        }
        private function __construct() {

            $this->define_constants();

            add_action( 'plugins_loaded', array( $this, 'init' ), 10 );

        }
        private function define_constants() {
            if ( ! defined( 'LLMS_Aqayepardakht_PLUGIN_FILE' ) ) {
                define( 'LLMS_Aqayepardakht_PLUGIN_FILE', __FILE__ );
            }

            if ( ! defined( 'LLMS_Aqayepardakht_PLUGIN_DIR' ) ) {
                define( 'LLMS_Aqayepardakht_PLUGIN_DIR', WP_PLUGIN_DIR . "/" . plugin_basename( dirname(__FILE__) ) . '/');
            }
        }
        public function init() {
            if ( function_exists( 'LLMS' ) && version_compare( '3.0.0-alpha', LLMS()->version, '<=' ) ) {
                add_action( 'lifterlms_settings_save_checkout', array( $this, 'maybe_check_reference_transactions' ) );
                add_filter( 'lifterlms_payment_gateways', array( $this, 'register_gateway' ), 10, 1 );
                require_once 'includes/class.llms.payment.gateway.aqayepardakht.php';
            }

        }
        public function maybe_check_reference_transactions() {

            $gateways = LLMS()->payment_gateways();
            $g = $gateways->get_gateway_by_id( 'Aqayepardakht' );
            $check = false;
            if ( isset( $_POST[ $g->get_option_name( 'MerchantID' ) ] ) && $g->get_MerchantID() !== $_POST[ $g->get_option_name( 'MerchantID' ) ] ) {
                $check = true;
            } elseif ( isset( $_POST['llms_gateway_Aqayepardakht_check_ref_trans'] ) ) {
                $check = true;
            }
            if ( $check ) {
                add_action( 'lifterlms_settings_saved', array( $g, 'check_reference_transactions' ) );
            }
        }
        public function register_gateway( $gateways ) {

            $gateways[] = 'LLMS_Payment_Gateway_Aqayepardakht';

            return $gateways;

        }
    }
endif;
function LLMS_Gateway_Aqayepardakht() {
    return LifterLMS_Aqayepardakht::instance();
}
return LLMS_Gateway_Aqayepardakht();
